set-variable [string]$tableName -scope global
set-Variable [string]$pathname -scope global

# ****************************************************************************
# Remember to add your own parameters for userid, password, and database below
# You must use this method of logging in as bcp requires $uid and $pwd
# in order to read the DB for the bul copy output to disk
# ****************************************************************************


[string]$server = ""
[string]$uid = ""
[string]$pwd = ""
[string]$database = ""

# you MUST install the pscx library!!!!
Import-Module pscx

# Set the path to the directory for backups - don't forget to check permissions.
$pathname = "C:\temp"



# Connection
$sqlConn = New-Object System.Data.SqlClient.SqlConnection
$sqlConn.ConnectionString = "Data Source="+$server+";User Id="+$uid+";Password="+$pwd+";Initial Catalog="+$database
$sqlConn.Open()




#get params SQL
$pds = new-object "System.Data.Dataset" 
$pq = "SELECT [TABLE_SCHEMA], [TABLE_NAME], [TABLE_TYPE]"
$pq = $pq + " FROM INFORMATION_SCHEMA.TABLES"
$pq = $pq + " WHERE [TABLE_TYPE] = 'BASE TABLE'"
$pq = $pq + " ORDER BY TABLE_NAME"

$pda = new-object "System.Data.SqlClient.SqlDataAdapter" ($pq, $sqlConn)
$pda.Fill($pds)
$pdtUser = new-object "System.Data.DataTable"
$pdtUser = $pds.Tables[0]

$pdtUser | FOREACH-OBJECT {
    $tableName = $_.TABLE_NAME
    $tableSchema = $_.TABLE_SCHEMA

   
        try {
        bcp [$database].[$tableSchema].$tableName out $pathname\$tableName.csv -U $uid -P $pwd -S $server -t "," /c
	     } catch {
		$msg = "Error copying files. " + $tableName + " - " + $error[0]
		Write-Warning $msg
        }
       
    } # end foreach





$sqlConn.Close()

Remove-variable tableName
Remove-variable pathname

"Completed"